define("esri/layers/dynamic", ["esri/geometry", "esri/layers/DynamicMapServiceLayer"], function () {
    return {};
});

define(
    "esri/layers/WMSLayerInfo",
    ["dojo/_base/declare", "dojo/_base/lang", "dojo/_base/array", "dojo/has", "esri/kernel"],
    function (_1, _2, _3, _4, _5) {
        var _6 = _1(
            null,
            {
                declaredClass:"esri.layers.WMSLayerInfo",
                name:null,
                title:null,
                description:null,
                extent:null,
                legendURL:null,
                subLayers:[],
                allExtents:[],
                spatialReferences:[],
                constructor:function (_7) {
                    if (_7) {
                        this.name = _7.name;
                        this.title = _7.title;
                        this.description = _7.description;
                        this.extent = _7.extent;
                        this.legendURL = _7.legendURL;
                        this.subLayers = _7.subLayers ? _7.subLayers : [];
                        this.allExtents = _7.allExtents ? _7.allExtents : [];
                        this.spatialReferences = _7.spatialReferences ? _7.spatialReferences : [];
                    }
                },
                clone:function () {
                    var _8 = {
                            name:this.name,
                            title:this.title,
                            description:this.description,
                            legendURL:this.legendURL
                        },
                        _9;
                    if (this.extent) {
                        _8.extent = this.extent.getExtent();
                    }
                    _8.subLayers = [];
                    _3.forEach(this.subLayers, function (_a) {
                        _8.subLayers.push(_a.clone());
                    });
                    _8.allExtents = [];
                    for (_9 in this.allExtents) {
                        _9 = parseInt(_9, 10);
                        if (!isNaN(_9)) {
                            _8.allExtents[_9] = this.allExtents[_9].getExtent();
                        }
                    }
                    _8.spatialReferences = [];
                    _3.forEach(this.spatialReferences, function (_b) {
                            _8.spatialReferences.push(_b);
                        }
                    );
                    return _8;
                }
            }
        );
        if (_4("extend-esri")) {
            _2.setObject("layers.WMSLayerInfo", _6, _5);
        }
        return _6;
    }
);

define(
    "esri/layers/WMSLayer",
    ["require", "dojo/_base/kernel", "dojo/_base/declare", "dojo/_base/lang", "dojo/_base/array", "dojo/has", "esri/kernel", "esri/request", "esri/urlUtils", "esri/SpatialReference", "esri/geometry/Extent", "esri/layers/DynamicMapServiceLayer", "esri/layers/WMSLayerInfo", "dojo/query"],
    function (_1, _2, _3, _4, _5, _6, _7, _8, _9, _a, _b, _c, _d) {
        var _e = _3([_c],
            {
                declaredClass:"esri.layers.WMSLayer",
                _CRS_TO_EPSG:{84:4326, 83:4269, 27:4267},
                _REVERSED_LAT_LONG_RANGES:[
                    [4001, 4999],
                    [2044, 2045],
                    [2081, 2083],
                    [2085, 2086],
                    [2093, 2093],
                    [2096, 2098],
                    [2105, 2132],
                    [2169, 2170],
                    [2176, 2180],
                    [2193, 2193],
                    [2200, 2200],
                    [2206, 2212],
                    [2319, 2319],
                    [2320, 2462],
                    [2523, 2549],
                    [2551, 2735],
                    [2738, 2758],
                    [2935, 2941],
                    [2953, 2953],
                    [3006, 3030],
                    [3034, 3035],
                    [3058, 3059],
                    [3068, 3068],
                    [3114, 3118],
                    [3126, 3138],
                    [3300, 3301],
                    [3328, 3335],
                    [3346, 3346],
                    [3350, 3352],
                    [3366, 3366],
                    [3416, 3416],
                    [20004, 20032],
                    [20064, 20092],
                    [21413, 21423],
                    [21473, 21483],
                    [21896, 21899],
                    [22171, 22177],
                    [22181, 22187],
                    [22191, 22197],
                    [25884, 25884],
                    [27205, 27232],
                    [27391, 27398],
                    [27492, 27492],
                    [28402, 28432],
                    [28462, 28492],
                    [30161, 30179],
                    [30800, 30800],
                    [31251, 31259],
                    [31275, 31279],
                    [31281, 31290],
                    [31466, 31700]
                ],
                _WEB_MERCATOR:[102100, 3857, 102113, 900913],
                _WORLD_MERCATOR:[3395, 54004],
                allExtents:[],
                constructor:function (_f, _10) {
                    _f = this._stripParameters(_f, ["version", "service", "request", "bbox", "format", "height", "width", "layers", "srs", "crs", "styles", "transparent", "bgcolor", "exceptions", "time", "elevation", "sld", "wfs"]);
                    this.url = _f;
                    this._url = _9.urlToObject(_f);
                    this._getCapabilitiesURL = _f;
                    this._initLayer = _4.hitch(this, this._initLayer);
                    this._parseCapabilities = _4.hitch(this, this._parseCapabilities);
                    this._getCapabilitiesError = _4.hitch(this, this._getCapabilitiesError);

                    if (_10) {
                        this.imageFormat = this._getImageFormat(_10.format);
                        this.imageTransparency = (_10.transparent === false) ? false : true;
                        this.visibleLayers = _10.visibleLayers ? _10.visibleLayers : [];
                        if (_10.resourceInfo) {
                            this._readResourceInfo(_10.resourceInfo);
                        } else {
                            this._getCapabilities();
                        }
                    }
                    else {
                        this.imageFormat = "image/png";
                        this.imageTransparency = true;
                        this.visibleLayers = [];
                        this._getCapabilities();
                    }
                    this._blankImageURL = _1.toUrl("esri/layers") + "/../images/pixel.png";
                },
                setVisibleLayers:function (_11) {
                    _11 = this._checkVisibleLayersList(_11);
                    this.visibleLayers = _11 ? _11 : [];
                    this.refresh(true);
                },
                setImageFormat:function (_12) {
                    this.imageFormat = this._getImageFormat(_12);
                    this.refresh(true);
                },
                setImageTransparency:function (_13) {
                    this.imageTransparency = _13;
                    this.refresh(true);
                },
                getImageUrl:function (_14, _15, _16, _17) {
                    if (!this.visibleLayers || this.visibleLayers.length === 0) {
                        _17(this._blankImageURL);
                        return;
                    }
                    var _18 = _14.spatialReference.wkid;

                    if (
                        _5.some(
                            this._WEB_MERCATOR,
                            function (el) {
                                return el == _18;
                            }
                        )
                    ) {
                        var _19 = _5.filter(this.spatialReferences, function (el) {
                            return (_5.some(this._WEB_MERCATOR, function (el2) {
                                return el2 == el;
                            }));
                        }, this);
                        if (_19.length == 0) {
                            _19 = _5.filter(this.spatialReferences, function (el) {
                                return (_5.some(this._WORLD_MERCATOR, function (el2) {
                                    return el2 == el;
                                }));
                            }, this);
                        }
                        if (_19.length > 0) {
                            _18 = _19[0];
                        } else {
                            _18 = this._WEB_MERCATOR[0];
                        }
                    }
                    var _1a = _5.filter(this.spatialReferences, function (el) {
                        return el !== _18;
                    });

                    this.spatialReferences = _1a;
                    this.spatialReferences.unshift(_18);
                    var _1b = _14.xmin;
                    var _1c = _14.xmax;
                    var _1d = _14.ymin;
                    var _1e = _14.ymax;
                    var _1f = {};
                    _1f.SERVICE = "WMS";
                    _1f.REQUEST = "GetMap";
                    _1f.FORMAT = this.imageFormat;
                    _1f.TRANSPARENT = this.imageTransparency ? "TRUE" : "FALSE";
                    _1f.STYLES = "";
                    _1f.VERSION = this.version;
                    _1f.LAYERS = this.visibleLayers ? this.visibleLayers.toString() : null;
                    _1f.WIDTH = _15;
                    _1f.HEIGHT = _16;
                    if (this.maxWidth < _15) {
                        _1f.WIDTH = this.maxWidth;
                    }
                    if (this.maxHeight < _16) {
                        _1f.HEIGHT = this.maxHeight;
                    }
                    var _20 = _18 ? _18 : NaN;
                    if (!isNaN(_20)) {
                        if (this.version == "1.3.0") {
                            _1f.CRS = "EPSG:" + _20;
                        } else {
                            _1f.SRS = "EPSG:" + _20;
                        }
                    }
                    if (this.version == "1.3.0" && this._useLatLong(_20)) {
                        _1f.BBOX = _1d + "," + _1b + "," + _1e + "," + _1c;
                    } else {
                        _1f.BBOX = _1b + "," + _1d + "," + _1c + "," + _1e;
                    }
                    var _21 = this.getMapURL, key;

                    _1f.SRS = "EPSG:3857";

                    _21 += (_21.indexOf("?") == -1) ? "?" : "";
                    for (key in _1f) {
                        _21 += (_21.substring(_21.length - 1, _21.length) == "?") ? "" : "&";
                        _21 += key + "=" + _1f[key];
                    }
                    _17(_9.addProxy(_21));
                },
                _initLayer:function (_22, io) {
                    this.spatialReference = new _a(this.extent.spatialReference);
                    this.initialExtent = new _b(this.extent);
                    this.fullExtent = new _b(this.extent);
                    this.visibleLayers = this._checkVisibleLayersList(this.visibleLayers);
                    this.loaded = true;
                    this.onLoad(this);
                    var _23 = this._loadCallback;
                    if (_23) {
                        delete this._loadCallback;
                        _23(this);
                    }
                },
                _readResourceInfo:function (_24) {
                    if (!_24.extent) {
                        console.error("esri.layers.WMSLayer: unable to find the 'extent' property in resourceInfo");
                        return;
                    }
                    if (!_24.layerInfos) {
                        console.error("esri.layers.WMSLayer: unable to find the 'layerInfos' property in resourceInfo");
                        return;
                    }
                    this.extent = _24.extent;
                    this.allExtents[0] = _24.extent;
                    this.layerInfos = _24.layerInfos;
                    this.description = _24.description ? _24.description : "";
                    this.copyright = _24.copyright ? _24.copyright : "";
                    this.title = _24.title ? _24.title : "";
                    this.getMapURL = _24.getMapURL ? _24.getMapURL : this._getCapabilitiesURL;
                    this.version = _24.version ? _24.version : "1.3.0";
                    this.maxWidth = _24.maxWidth ? _24.maxWidth : 5000;
                    this.maxHeight = _24.maxHeight ? _24.maxHeight : 5000;
                    this.spatialReferences = _24.spatialReferences ? _24.spatialReferences : [];
                    this.imageFormat = this._getImageFormat(_24.format);
                    this.setScaleRange(_24.minScale, _24.maxScale);
                    this._initLayer();
                },
                _getCapabilities:function () {
                    var _25 = this._url.query ? this._url.query : {};
                    _25.SERVICE = "WMS";
                    _25.REQUEST = "GetCapabilities";
                    var uri = this._url.path + "?", key;
                    for (key in _25) {
                        uri += (uri.substring(uri.length - 1, uri.length) == "?") ? "" : "&";
                        uri += key + "=" + _25[key];
                    }

                    uri = this._wrapUrlProxy(uri);
                    var _26 = _8(
                        {
                            url:uri,
                            handleAs:"xml",
                            load:this._parseCapabilities,
                            error:this._getCapabilitiesError
                        },
                        {
                            usePost:false
                        }
                    );
                },
                _wrapUrlProxy:function (url) {
                    var a = document.createElement("a");

                    a.href = url;

                    if (window.location.hostname != a.hostname ||
                        window.location.port != a.port) {
                        return 'proxy?' + encodeURIComponent(url);
                    }
                    else {
                        return url;
                    }
                },
                _parseCapabilities:function (xml) {
                    if (!xml) {
                        this.onError("GetCapabilities request for " + this._getCapabilitiesURL + " failed. (Response is null.)");
                        return;
                    }
                    this.version = this._getAttributeValue("WMS_Capabilities", "version", xml, null);
                    if (!this.version) {
                        this.version = this._getAttributeValue("WMT_MS_Capabilities", "version", xml, "1.3.0");
                    }
                    var _27 = this._getTag("Service", xml);
                    this.title = this._getTagValue("Title", _27, "");
                    if (!this.title || this.title.length == 0) {
                        this.title = this._getTagValue("Name", _27, "");
                    }
                    this.copyright = this._getTagValue("AccessConstraints", _27, "");
                    this.description = this._getTagValue("Abstract", _27, "");
                    this.maxWidth = parseInt(this._getTagValue("MaxWidth", _27, 5000), 10);
                    this.maxHeight = parseInt(this._getTagValue("MaxHeight", _27, 5000), 10);
                    var _28 = this._getTag("Layer", xml);
                    if (!_28) {
                        this._getCapabilitiesError({"error":{"message":"Response does not contain any layers."}});
                        return;
                    }
                    var _29 = this._getLayerInfo(_28);
                    if (_29) {
                        this.layerInfos = _29.subLayers;
                        if (!this.layerInfos || this.layerInfos.length == 0) {
                            this.layerInfos = [_29];
                        }
                        this.extent = _29.extent;
                        this.allExtents = _29.allExtents;
                        this.spatialReferences = _29.spatialReferences;
                        if (this.spatialReferences.length == 0 && this.layerInfos.length > 0) {
                            this.spatialReferences = this.layerInfos[0].spatialReferences;
                        }
                    }
                    this.getMapURL = this._getCapabilitiesURL;
                    var _2a = _2.query("DCPType", this._getTag("GetMap", xml));
                    if (_2a && _2a.length > 0) {
                        var _2b = _2.query("HTTP", _2a[0]);
                        if (_2b && _2b.length > 0) {
                            var _2c = _2.query("Get", _2b[0]);
                            if (_2c && _2c.length > 0) {
                                var _2d = this._getAttributeValue("OnlineResource", "xlink:href", _2c[0], null);
                                if (_2d) {
                                    if (_2d.indexOf("&") == (_2d.length - 1)) {
                                        _2d = _2d.substring(0, _2d.length - 1);
                                    }
                                    this.getMapURL = _2d;
                                }
                            }
                        }
                    }
                    this.getMapFormats = [];
                    if (_2.query("Operation", xml).length == 0) {
                        _5.forEach(_2.query("Format", this._getTag("GetMap", xml)), function (_2e) {
                            this.getMapFormats.push(_2e.text ? _2e.text : _2e.textContent);
                        }, this);
                    } else {
                        _5.forEach(_2.query("Operation", xml), function (_2f) {
                            if (_2f.getAttribute("name") == "GetMap") {
                                _5.forEach(_2.query("Format", _2f), function (_30) {
                                    this.getMapFormats.push(_30.text ? _30.text : _30.textContent);
                                }, this);
                            }
                        }, this);
                    }
                    if (!_5.some(this.getMapFormats, function (el) {
                        return el.indexOf(this.imageFormat) > -1;
                    }, this)) {
                        this.imageFormat = this.getMapFormats[0];
                    }
                    this._initLayer();
                },
                _getCapabilitiesError:function (_31, io) {
                    this.onError("GetCapabilities request for " + this._getCapabilitiesURL + " failed.", _31);
                },
                _getLayerInfo:function (_32) {
                    if (!_32) {
                        return null;
                    }
                    var _33 = new _d();
                    _33.name = "";
                    _33.title = "";
                    _33.description = "";
                    _33.allExtents = [];
                    _33.spatialReferences = [];
                    _33.subLayers = [];
                    var _34 = this._getTag("LatLonBoundingBox", _32);
                    if (_34) {
                        _33.allExtents[0] = this._getExtent(_34, 4326);
                    }
                    var _35 = this._getTag("EX_GeographicBoundingBox", _32);
                    if (_35) {
                        var _36 = new _b(0, 0, 0, 0, new _a({wkid:4326}));
                        _36.xmin = parseFloat(this._getTagValue("westBoundLongitude", _35, 0));
                        _36.ymin = parseFloat(this._getTagValue("southBoundLatitude", _35, 0));
                        _36.xmax = parseFloat(this._getTagValue("eastBoundLongitude", _35, 0));
                        _36.ymax = parseFloat(this._getTagValue("northBoundLatitude", _35, 0));
                        _33.allExtents[0] = _36;
                    }
                    _33.extent = _33.allExtents[0];
                    var _37 = (_5.indexOf(["1.0.0", "1.1.0", "1.1.1"], this.version) > -1) ? "SRS" : "CRS";
                    _5.forEach(_32.childNodes, function (_38) {
                        if (_38.nodeName == "Name") {
                            _33.name = (_38.text ? _38.text : _38.textContent) || "";
                        } else {
                            if (_38.nodeName == "Title") {
                                _33.title = (_38.text ? _38.text : _38.textContent) || "";
                            } else {
                                if (_38.nodeName == "Abstract") {
                                    _33.description = (_38.text ? _38.text : _38.textContent) || "";
                                } else {
                                    if (_38.nodeName == "BoundingBox") {
                                        var _39 = _38.getAttribute(_37), _3a;
                                        if (_39 && _39.indexOf("EPSG:") === 0) {
                                            _3a = parseInt(_39.substring(5), 10);
                                            if (_3a !== 0 && !isNaN(_3a)) {
                                                var _3b;
                                                if (this.version == "1.3.0") {
                                                    _3b = this._getExtent(_38, _3a, this._useLatLong(_3a));
                                                } else {
                                                    _3b = this._getExtent(_38, _3a);
                                                }
                                                _33.allExtents[_3a] = _3b;
                                                if (!_33.extent) {
                                                    _33.extent = _3b;
                                                }
                                            }
                                        } else {
                                            if (_39 && _39.indexOf("CRS:") === 0) {
                                                _3a = parseInt(_39.substring(4), 10);
                                                if (_3a !== 0 && !isNaN(_3a)) {
                                                    if (this._CRS_TO_EPSG[_3a]) {
                                                        _3a = this._CRS_TO_EPSG[_3a];
                                                    }
                                                    _33.allExtents[_3a] = this._getExtent(_38, _3a);
                                                }
                                            } else {
                                                _3a = parseInt(_39, 10);
                                                if (_3a !== 0 && !isNaN(_3a)) {
                                                    _33.allExtents[_3a] = this._getExtent(_38, _3a);
                                                }
                                            }
                                        }
                                    } else {
                                        if (_38.nodeName == _37) {
                                            var _3c = _38.text ? _38.text : _38.textContent;
                                            var arr = _3c.split(" ");
                                            _5.forEach(arr, function (val) {
                                                if (val.indexOf(":") > -1) {
                                                    val = parseInt(val.split(":")[1], 10);
                                                } else {
                                                    val = parseInt(val, 10);
                                                }
                                                if (val !== 0 && !isNaN(val)) {
                                                    if (this._CRS_TO_EPSG[val]) {
                                                        val = this._CRS_TO_EPSG[val];
                                                    }
                                                    if (_5.indexOf(_33.spatialReferences, val) == -1) {
                                                        _33.spatialReferences.push(val);
                                                    }
                                                }
                                            }, this);
                                        } else {
                                            if (_38.nodeName == "Style") {
                                                var _3d = this._getTag("LegendURL", _38);
                                                if (_3d) {
                                                    var _3e = this._getTag("OnlineResource", _3d);
                                                    if (_3e) {
                                                        _33.legendURL = _3e.getAttribute("xlink:href");
                                                    }
                                                }
                                            } else {
                                                if (_38.nodeName === "Layer") {
                                                    _33.subLayers.push(this._getLayerInfo(_38));
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }, this);
                    return _33;
                },
                _getImageFormat:function (_3f) {
                    var _40 = _3f ? _3f.toLowerCase() : "";
                    switch (_40) {
                        case "jpg":
                            return "image/jpeg";
                        case "bmp":
                            return "image/bmp";
                        case "gif":
                            return "image/gif";
                        case "svg":
                            return "image/svg+xml";
                        default:
                            return "image/png";
                    }
                },
                getImageFormat:function () {
                    var _41 = this.imageFormat ? this.imageFormat.toLowerCase() : "";
                    switch (_41) {
                        case "image/jpeg":
                            return "jpg";
                        case "image/bmp":
                            return "bmp";
                        case "image/gif":
                            return "gif";
                        case "image/svg+xml":
                            return "svg";
                        default:
                            return "png";
                    }
                },
                _getExtent:function (_42, _43, _44) {
                    var _45;
                    if (_42) {
                        _45 = new _b();
                        var _46 = parseFloat(_42.getAttribute("minx"));
                        var _47 = parseFloat(_42.getAttribute("miny"));
                        var _48 = parseFloat(_42.getAttribute("maxx"));
                        var _49 = parseFloat(_42.getAttribute("maxy"));
                        if (_44) {
                            _45.xmin = isNaN(_47) ? ((-1) * Number.MAX_VALUE) : _47;
                            _45.ymin = isNaN(_46) ? ((-1) * Number.MAX_VALUE) : _46;
                            _45.xmax = isNaN(_49) ? Number.MAX_VALUE : _49;
                            _45.ymax = isNaN(_48) ? Number.MAX_VALUE : _48;
                        } else {
                            _45.xmin = isNaN(_46) ? ((-1) * Number.MAX_VALUE) : _46;
                            _45.ymin = isNaN(_47) ? ((-1) * Number.MAX_VALUE) : _47;
                            _45.xmax = isNaN(_48) ? Number.MAX_VALUE : _48;
                            _45.ymax = isNaN(_49) ? Number.MAX_VALUE : _49;
                        }
                        _45.spatialReference = new _a({wkid:_43});
                    }
                    return _45;
                },
                _useLatLong:function (_4a) {
                    var _4b, i;
                    for (i = 0; i < this._REVERSED_LAT_LONG_RANGES.length; i++) {
                        var _4c = this._REVERSED_LAT_LONG_RANGES[i];
                        if (_4a >= _4c[0] && _4a <= _4c[1]) {
                            _4b = true;
                            break;
                        }
                    }
                    return _4b;
                },
                _getTag:function (_4d, xml) {
                    var _4e = _2.query(_4d, xml);
                    if (_4e && _4e.length > 0) {
                        return _4e[0];
                    } else {
                        return null;
                    }
                },
                _getTagValue:function (_4f, xml, _50) {
                    var _51 = _2.query(_4f, xml);
                    if (_51 && _51.length > 0) {
                        if (_51[0].text) {
                            return _51[0].text;
                        } else {
                            return _51[0].textContent;
                        }
                    } else {
                        return _50;
                    }
                },
                _getAttributeValue:function (_52, _53, xml, _54) {
                    var _55 = _2.query(_52, xml);
                    if (_55 && _55.length > 0) {
                        return _55[0].getAttribute(_53);
                    } else {
                        return _54;
                    }
                },
                _checkVisibleLayersList:function (_56) {
                    if (_56 && _56.length > 0 && this.layerInfos && this.layerInfos.length > 0) {
                        if ((typeof _56[0]) == "number") {
                            var _57 = [];
                            _5.forEach(_56, function (pos) {
                                if (pos < this.layerInfos.length) {
                                    _57.push(this.layerInfos[pos].name);
                                }
                            }, this);
                            _56 = _57;
                        }
                    }
                    return _56;
                },
                _stripParameters:function (url, _58) {
                    var obj = _9.urlToObject(url), _59, qs = [];
                    for (_59 in obj.query) {
                        if (_5.indexOf(_58, _59.toLowerCase()) === -1) {
                            qs.push(_59 + "=" + obj.query[_59]);
                        }
                    }
                    return obj.path + (qs.length ? ("?" + qs.join("&")) : "");
                }
            }
        );

        if (_6("extend-esri")) {
            _4.setObject("layers.WMSLayer", _e, _7);
        }

        return _e;
    }
);

define("esri/layers/wms", ["esri/layers/agscommon", "esri/layers/dynamic", "esri/layers/WMSLayer"], function () {
    return {};
});
